'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _keys = require('babel-runtime/core-js/object/keys');

var _keys2 = _interopRequireDefault(_keys);

var _stringify = require('babel-runtime/core-js/json/stringify');

var _stringify2 = _interopRequireDefault(_stringify);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _mockerInterface = require('./mockerInterface');

var _sinon = require('sinon');

var _sinon2 = _interopRequireDefault(_sinon);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var ClientMocker = function (_Mocker) {
  (0, _inherits3.default)(ClientMocker, _Mocker);

  function ClientMocker() {
    var _ref;

    var _temp, _this, _ret;

    (0, _classCallCheck3.default)(this, ClientMocker);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = (0, _possibleConstructorReturn3.default)(this, (_ref = ClientMocker.__proto__ || (0, _getPrototypeOf2.default)(ClientMocker)).call.apply(_ref, [this].concat(args))), _this), _this._server = null, _this._failIfServerWasNotCreated = function () {
      if (!_this._server) {
        throw new Error('You should call create() first');
      }
    }, _temp), (0, _possibleConstructorReturn3.default)(_this, _ret);
  }

  (0, _createClass3.default)(ClientMocker, [{
    key: 'create',
    value: function create() {
      this._server = _sinon2.default.fakeServer.create();
      this._server.respondImmediately = true;
    }
  }, {
    key: 'restore',
    value: function restore() {
      this._failIfServerWasNotCreated();
      this._server.restore();
    }
  }, {
    key: 'httpMock',
    value: function httpMock(baseUrl) {
      this._failIfServerWasNotCreated();
      return new ClientMock(this._server, baseUrl);
    }
  }]);
  return ClientMocker;
}(_mockerInterface.Mocker);

var ClientMock = function (_Mock) {
  (0, _inherits3.default)(ClientMock, _Mock);

  function ClientMock(server, baseUrl) {
    (0, _classCallCheck3.default)(this, ClientMock);

    var _this2 = (0, _possibleConstructorReturn3.default)(this, (ClientMock.__proto__ || (0, _getPrototypeOf2.default)(ClientMock)).call(this));

    _this2._server = server;
    _this2._isRegexp = false;
    _this2._baseUrl = baseUrl;
    _this2._method = null;
    _this2._query = '';
    _this2._path = null;
    _this2._responseResolver = function (identity) {
      return identity;
    };
    return _this2;
  }

  (0, _createClass3.default)(ClientMock, [{
    key: 'get',
    value: function get(path) {
      this._method = 'GET';
      this._path = path;
      this._responseResolver = function (response) {
        return (0, _stringify2.default)(response);
      };

      return this;
    }
  }, {
    key: 'getRegexp',
    value: function getRegexp(path) {
      this.get(path);
      this._isRegexp = true;

      return this;
    }
  }, {
    key: 'post',
    value: function post(path) {
      this._method = 'POST';
      this._path = path;
      this._responseResolver = function (response, statusCode) {
        var headers = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : { 'Content-Type': 'application/json' };
        return [statusCode, headers, (0, _stringify2.default)(response)];
      };

      return this;
    }
  }, {
    key: 'query',
    value: function query(queryObject) {
      this._query = '?' + (0, _keys2.default)(queryObject).reduce(function (acc, param) {
        var value = queryObject[param];
        acc.push(param + '=' + value);

        return acc;
      }, []).join('&');

      return this;
    }
  }, {
    key: 'reply',
    value: function reply(response) {
      var statusCode = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 200;
      var headers = arguments[2];

      this._server.respondWith(this._method, this._isRegexp ? RegExp('' + this._baseUrl + this._path + this._query) : '' + this._baseUrl + this._path + this._query, this._responseResolver(response, statusCode, headers));
    }
  }]);
  return ClientMock;
}(_mockerInterface.Mock);

exports.default = ClientMocker;