'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _stringify = require('babel-runtime/core-js/json/stringify');

var _stringify2 = _interopRequireDefault(_stringify);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _mockerInterface = require('./mockerInterface');

var _nock = require('nock');

var _nock2 = _interopRequireDefault(_nock);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var ServerMocker = function (_Mocker) {
  (0, _inherits3.default)(ServerMocker, _Mocker);

  function ServerMocker() {
    (0, _classCallCheck3.default)(this, ServerMocker);
    return (0, _possibleConstructorReturn3.default)(this, (ServerMocker.__proto__ || (0, _getPrototypeOf2.default)(ServerMocker)).apply(this, arguments));
  }

  (0, _createClass3.default)(ServerMocker, [{
    key: 'httpMock',
    value: function httpMock(baseUrl) {
      return new ServerMock(_nock2.default, baseUrl);
    }
  }]);
  return ServerMocker;
}(_mockerInterface.Mocker);

var ServerMock = function (_Mock) {
  (0, _inherits3.default)(ServerMock, _Mock);

  function ServerMock(server, baseUrl) {
    (0, _classCallCheck3.default)(this, ServerMock);

    var _this2 = (0, _possibleConstructorReturn3.default)(this, (ServerMock.__proto__ || (0, _getPrototypeOf2.default)(ServerMock)).call(this));

    _this2._server = server;
    _this2._baseUrl = baseUrl;
    _this2._method = null;
    _this2._query = null;
    _this2._path = null;
    return _this2;
  }

  (0, _createClass3.default)(ServerMock, [{
    key: 'get',
    value: function get(path) {
      this._method = 'get';
      this._path = path;

      return this;
    }
  }, {
    key: 'getRegexp',
    value: function getRegexp(path) {
      this.get(path);
      this._path = RegExp(path);

      return this;
    }
  }, {
    key: 'post',
    value: function post(path) {
      this._method = 'post';
      this._path = path;

      return this;
    }
  }, {
    key: 'query',
    value: function query(queryObject) {
      this._query = queryObject;

      return this;
    }
  }, {
    key: 'reply',
    value: function reply(response) {
      var statusCode = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 200;

      var mock = this._server(this._baseUrl)[this._method](this._path);

      if (this._query) {
        mock.query(this._query);
      }

      mock.reply(statusCode, (0, _stringify2.default)(response));
    }
  }]);
  return ServerMock;
}(_mockerInterface.Mock);

exports.default = ServerMocker;